import * as childProcess from 'child_process';

/**
 * Downloads a file using a curl child process, to allow for speed-limiting and timeout if download is too slow.
 * Takes as input the host domain name, the path and the file size
 */
export default function downloadWithCurl({ host, path, tempFileName, size, resolve, reject }: {host: string, path: string, tempFileName: string, size: number, resolve: (downloadedFile: string) => void, reject: () => void}): void {
  const url = `http://${host}${(path.substr(0, 1) === '/' ? '' : '/')}${path}`;

  const parameters: string[] = [
    //...
    '--output', tempFileName,
    url,
  ];

  const spawnedProcess = childProcess.spawn('curl', parameters);

  resolve(tempFileName);
}
